/****************************************************************************
Tue 6/28/2005 4:42 pm. This code is based on an example I found on the web,
which was apparently designed to impress us .NET pilgrims with how
terrifyingly sharp the guy was, and how dumb I was. Didn't work, but in honor
of these lofty aspirations, I have dubbed it the "Serial Resume Enhancer
Demo".

Description of SerialPort is at
http://msdn2.microsoft.com/library/e96b0a7f(en-us,vs.80).aspx + it's in the
MSDN documentation you might install with Beta 2. NOT in the context help I
don't think.

I've denoted the original comments with //// four slashes.

j.g. owen * * * * * * * * * * * * * * * * * * *
web:   http://owenlabs.home.att.net/
email: owen_bda4@yahoo.com
* * * * * * * * * * * * * * * * * * * * * * * *

****************************************************************************/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

/****************************************************************************
note there is a jgo.cs with one or two sbrs that is part of this excitement.
****************************************************************************/

namespace Serialexample
{
  partial class Form1 : Form
  {
    ////create instance of property page
    ////property page is used to set values for stop bits and
    ////baud rate

    PropertyPage pp = new PropertyPage();

    ////create an Serial Port object
    SerialPort sp = new SerialPort();

    public Form1()
    {
      InitializeComponent();


      sp.NewLine = "\r\n";
      //this seems to only affect readln. Altho it seemed to work before I did
      //this.

      sp.Encoding = Encoding.ASCII;
      sp.BaudRate = 4800;   //default baud.
      sp.ReadTimeout = 500; //Original author hides this.
      sp.RtsEnable = true;
      sp.DtrEnable = true;

/****************************************************************************
Tue 6/28/2005 2:52 pm. This comes under the "Old-RS232 Folk Knowledge"
heading:

1. Don't EVER use RTS/CTS DTR/DSR for flow control; use something higher-up,
in software.

2. But ALWAYS set RTS and DTR -- as I forgot, again -- because various stupid
equipment won't cooperate otherwise.

In this case, I was trying to talk to something that was connected via an
RS422-RS232 adapter-- which is powered by one of those signals! Didn't work
good until I turned them on. It's not normally that extreme; but the IBM BIOS
serial function wouldn't (probably still won't) talk until CTS was high.
That's the reason all these RS232 primers show a connection where RTS/CTS and
DTR/DSR are each shorted without connecting to anything in the cable -- so
they won't interfere with serial traffic. But you have to have a soldering
iron for that!

****************************************************************************/

    }

/****************************************************************************
Stick stuff in textBox_Statoid. I replaced a random assortment of labels with
this.
****************************************************************************/

    private void add_stat(String s) {
      jgo.add_box(textBox_Statoid,s);
    }

    private void focus_chat() {
      textBox_write.Show();
      textBox_write.SelectAll();
      textBox_write.Focus();
    }

    private void propertyButton_Click(object sender, EventArgs e)
    {
      pp.bRate = sp.BaudRate.ToString();
      pp.sBits = sp.StopBits.ToString();
      pp.comm_port = sp.PortName;

      ////show property dialog
      if (pp.ShowDialog() == DialogResult.OK) {
        switch (pp.sBits) {
/****************************************************************************
Hey what about actually setting the serial ports to the specified baud, stop
bits, eh?
****************************************************************************/
          case "One": sp.StopBits = StopBits.One; break;
          case "Two": sp.StopBits = StopBits.Two; break;
        }

        sp.BaudRate = jgo.StrToInt(pp.bRate);
        sp.PortName = pp.comm_port;

        propertyButton.Hide();

      }

    }

/****************************************************************************
Centralize the routine to send serial stuff.
****************************************************************************/
    private void sendstuff() {
      try
      {
        sp.Write(textBox_write.Text+"\r\n");
/****************************************************************************
That sends it with a line space, probably \r\n... ... And lets log it.
****************************************************************************/
        jgo.add_box(textBox,"s:\t"+textBox_write.Text);
        focus_chat();
      }
      catch (System.Exception ex)
      {
        textBox_Statoid.Text = ex.Message;
      }
    }

    private void sendButton_Click(object sender, EventArgs e) {
      sendstuff();
    }

    private void ReadButton_Click(object sender, EventArgs e)
    {
      try
      {
        jgo.add_box(textBox,"r:\t"+sp.ReadLine());
        focus_chat();
      }
      catch (System.Exception ex)
      {
        textBox_Statoid.Text = ex.Message;
      }
    }

  private void Form1_FormClosing(object sender, FormClosingEventArgs e)
    {
      MessageBox.Show("Do u want to Close the App");
      sp.Close();
    }

    private void startCommButton_Click(object sender, EventArgs e)
    {
      add_stat("");     //make it go away.
      startCommButton.Hide();
      sendButton.Show();
      readButton.Show();
      textBox.Text =
      "Type stuff above, press Enter (or click SEND).\r\n"+
      "Or click READ to see what the program on the other computer "+
      "has to say\r\n"+
      "----------------------------------------------\r\n"
      ;
      textBox.Show();
      focus_chat();
    }

    ////when we want to save the status(value)
/****************************************************************************
I don't know why he called it saveStatus. This is where he starts the comm;
if, for instance, COM4 is specified and the system doesn't have a COM4, this
is where it will fail. The "startCommButton" button (above) just fiddles the
form so it's possible to use the demo.
****************************************************************************/
    private void saveStatusButton_Click_1(object sender, EventArgs e)
    {
      add_stat("");   //Clear the statoid.

      add_stat("BaudRate = " + sp.BaudRate.ToString());
      add_stat("StopBits = " + sp.StopBits.ToString());
      add_stat("DataBits = " + sp.DataBits.ToString());
      add_stat("Parity = " + sp.Parity.ToString());
      add_stat("ReadTimeout = " + sp.ReadTimeout.ToString());
      add_stat("Port = " + sp.PortName.ToString());

//    if (propertyButton.Visible == true)
//    unnecessary.
      propertyButton.Hide();

      saveStatusButton.Hide();
      startCommButton.Show();
      startCommButton.Focus();

      try
      {
        ////open serial port
        sp.Open();
      }
      catch (System.Exception ex)
      {
        textBox_Statoid.Text = ex.Message;
      }
    }

    private void textBox_write_KeyDown(object sender, KeyEventArgs e) {
      if (e.KeyCode == Keys.Enter) {
        sendstuff();
      }
    }
  }
}
